;;; Driver for parse-logs

(use parse-logs)

;;; Configuration

(define (available-logs)
  (let ((basedir "~/logs/"))
  (append 
   (glob (string-append basedir "access_log.1.200*"))
   (glob (string-append basedir "access_log.200*")))))

(define database-path "~/db/searches.db")

;;; Main

(define (main)
  (let ((db (open-db database-path)))
    (process-new-files db (available-logs))
    (sqlite3:finalize! db)))

(main)
